﻿// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

/////////////////////////////////////
// Plugin class
cr.plugins_.MassiveCube_FacebookInstantExtended = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{
	var pluginProto = cr.plugins_.MassiveCube_FacebookInstantExtended.prototype;
		
	/////////////////////////////////////
	// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

	typeProto.onCreate = function()
	{
	};

	/////////////////////////////////////
	// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		
		// Initialise object properties
		this.testProperty = 0;
	};
	
	var instanceProto = pluginProto.Instance.prototype;
	
	instanceProto.onCreate = function()
	{
		// Read properties set in C3
		this.testProperty = this.properties[0];
	};
	
	instanceProto.saveToJSON = function ()
	{
		return {};
	};
	
	instanceProto.loadFromJSON = function (o)
	{
	};
	
	/**BEGIN-PREVIEWONLY**/
	instanceProto.getDebuggerValues = function (propsections)
	{
	};
	/**END-PREVIEWONLY**/

	//////////////////////////////////////
	// Conditions
	function Cnds() {};
	
	
	pluginProto.cnds = new Cnds();

	//////////////////////////////////////
	// Actions
	function Acts() {};
	
	Acts.prototype.updateAsync = function (obj, data, action, notification, strategy, cta, template, text)
	{

		var self = this;
		var imageDataUri = null;
		
		if (obj)
		{
			var inst = obj.getFirstPicked();
			
			if (!inst || !inst.curFrame)
				return;
				
			var frame = inst.curFrame;
			imageDataUri = frame.getDataUri();
		}

		FBInstant["updateAsync"]({
			"action": action,
			"cta": cta,
			"image": imageDataUri,
			"text": text,
			"notification": notification,
			"strategy" : strategy,
			"template": template,
			"data": { "data": data }
		});
	};



	Acts.prototype.chooseAsync = function ()
	{
		FBInstant.context.chooseAsync().then(function() {
		    console.log(FBInstant.context.getID());
		    // 1234567890
		});
	};

	Acts.prototype.switchGameAsync = function (gameid)
	{
		FBInstant.switchGameAsync(gameid).catch(function (e) {
	  		console.log("Facebook (Error): Can not switch the game");
		});
	};

	pluginProto.acts = new Acts();

	//////////////////////////////////////
	// Expressions
	function Exps() {};
	
	
	pluginProto.exps = new Exps();

}());